﻿using System;
using System.Diagnostics;
using System.Runtime.CompilerServices;

// C# - 프로퍼티로 정의하면 필드보다 느릴까요?
// http://www.sysnet.pe.kr/2/0/1545

// 관련: 무한 재귀 호출 tailcall

class Program
{
    bool _result;

    public bool Result
    {
        get { return _result; }
        set { _result = value; }
    }

    static void Main(string[] args)
    {
        Program pg = new Program();

        Console.WriteLine(pg.Result);
/*
B9 BC B4 91 72       mov         ecx,7291B4BCh 
E8 0F 1F E8 FF       call        FFE81F3C 
8B C8                mov         ecx,eax 
0F B6 86 40 01 00 00 movzx       eax,byte ptr [esi+00000140h] 
88 41 04             mov         byte ptr [ecx+4],al 
E8 AA 81 D3 70       call        70D381E8 
*/

        Console.WriteLine(pg._result);
/*
B9 BC B4 91 72       mov         ecx,7291B4BCh 
E8 F4 1E E8 FF       call        FFE81F3C 
8B C8                mov         ecx,eax 
0F B6 86 40 01 00 00 movzx       eax,byte ptr [esi+00000140h] 
88 41 04             mov         byte ptr [ecx+4],al 
E8 8F 81 D3 70       call        70D381E8 
*/

        CallPrintStackTrace();
    }

    // [MethodImpl(MethodImplOptions.NoInlining | MethodImplOptions.NoOptimization)]
    static void CallPrintStackTrace()
    {
        string obj = null;
        obj.ToLower();
    }

    /* C# Comple - Debug Build
    // Token: 0x06000002 RID: 2 RVA: 0x0000205C File Offset: 0x0000025C
    private static void CallPrintStackTrace()
    {
        string obj = null;
        obj.ToLower();
    }
    */

    /* C# Comple - Release Build
    // Token: 0x06000002 RID: 2 RVA: 0x0000205C File Offset: 0x0000025C
    private static void CallPrintStackTrace()
    {
        string obj = null;
        obj.ToLower();
    }
    */

    /* Jit Compile - Debug Build
    Unhandled Exception: System.NullReferenceException: Object reference not set to an instance of an object.
       at _1_Compile2.Program.CallPrintStackTrace()
       at _1_Compile2.Program.Main(String[] args) 
    */

    /* Jit Compile - Release Build
    Unhandled Exception: System.NullReferenceException: Object reference not set to an instance of an object.
       at _1_Compile2.Program.Main(String[] args)
    */
}

