﻿using System;

// null 처리된 객체가 왜 GC에 의해 수집되지 않을까요?
// http://www.sysnet.pe.kr/2/0/10920

class Program
{
    static void Main(string[] args)
    {
        TestWeakReference();

        Console.ReadKey();
    }

    private static void TestWeakReference()
    {
        object m = new object();
        WeakReference refM = new WeakReference(m);

        m = null;

        GC.Collect();

        Console.WriteLine("약한 참조 원본: {0}", (m == null ? "null" : m));
        Console.WriteLine("약한 참조 참조: {0}", 
            (refM.Target == null ? "null" : refM.Target.GetHashCode().ToString()));
    }
}

/* Debug
약한 참조 원본: null
약한 참조 참조: 46104728 // 임의 값
*/

/* Release
약한 참조 원본: null
약한 참조 참조: null
*/
